Imports System.Text
Imports System.IO
Imports System.Windows
Imports System.Data
Imports BT_LF

Public Class frmLF

    ' - btrw-hdx.v1.40.frm fuer alles TIRIS, UNIQUE32/64, ZOODIAC
    '0 - EM 41xx (UNIQUE) - RO
    '2 - FDX-B ISO 11784/5-RO
    '4 - HDX Transponder (TI)-RW

    ' - btrw-rw.v1.40.frm fuer Q5, HITAG-S(1), HITAG-II, EM4305
    '1 - HITAG S/HITAG 1 - RW
    '5 - HITAG 2 - RW
    '3 - Q5 / 5557 / 5567 = RW
    '6 - EM 4305 - RW


    ' - btrw-ti.v1.40.frm fuer TITAN, UNIQUE32/64, ZOODIAC
    '0 - EM 41xx (UNIQUE) - RO
    '2 - FDX-B ISO 11784/5-RO
    '7 - EM4450/4550 (TITAN)-RW
    '04.11.2009 Hitag 2 wurde in SetItemsToListView umkopiert



    'Typ 0 - EM 41xx (UNIQUE) - RO
    'Typ 1 - HITAG S/HITAG 1 - RW
    'Typ 2 - FDX-B ISO 11784/5-RO
    'Typ 3 - Q5 / 5557 / 5567 = RW
    'Typ 4 - HDX Transponder (TI)-RW
    'Typ 5 - HITAG 2 - RW
    'Typ 6 - EM 4305 - RW
    'Typ 7 - EM4450/4550 (TITAN)-RW

    Public IsKeyAction As Boolean = False
    Public IsFirst As Boolean
    Private MySelectTagTyp As Integer

    'Private TagType As Integer
    'Private MyData As String
    'Private TLMError As String
    'Private WithEvents MyTLM30 As New TIDReaderTLM30


    'Typ 0 - EM 41xx (UNIQUE) - RO
    'Typ 1 - HITAG S/HITAG 1 - RW
    'Typ 2 - FDX-B ISO 11784/5 - RO
    'Typ 3 - Q5/AT5557/ATA5567 - RW
    'Typ 4 - HDX Transponder (TI) - RW
    'Typ 5 - HITAG 2 - RW
    'Typ 6 - EM4305 - RW
    'Typ 7 - EM4450/4550 (TITAN) - RW

    Public Sub SetItemsToListView(ByVal Version As String)
        TagView.Items.Clear()
        If Version.IndexOf("btrw-hdx") > 0 Then
            TagView.Items.Add("Typ 0 - EM 41xx (UNIQUE) - RO")
            TagView.Items.Add("Typ 2 - FDX-B ISO 11784/5 - RO")
            TagView.Items.Add("Typ 4 - HDX Transponder (TI) - RW")
        ElseIf Version.IndexOf("btrw-rw") > 0 Then
            TagView.Items.Add("Typ 1 - HITAG S/HITAG 1 - RW")
            TagView.Items.Add("Typ 3 - Q5/AT5557/ATA5567 - RW")
            TagView.Items.Add("Typ 5 - HITAG 2 - RW")
            TagView.Items.Add("Typ 6 - EM4305 - RW")
        ElseIf Version.IndexOf("btrw-ti") > 0 Then
            TagView.Items.Add("Typ 0 - EM 41xx (UNIQUE) - RO")
            TagView.Items.Add("Typ 2 - FDX-B ISO 11784/5 - RO")
            TagView.Items.Add("Typ 7 - EM4450/4550 (TITAN) - RW")
        Else
            TagView.Items.Add("Typ 0 - EM 41xx (UNIQUE) - RO")
            TagView.Items.Add("Typ 1 - HITAG S/HITAG 1 - RW")
            TagView.Items.Add("Typ 2 - FDX-B ISO 11784/5 - RO")
            TagView.Items.Add("Typ 3 - Q5/AT5557/ATA5567 - RW")
            TagView.Items.Add("Typ 4 - HDX Transponder (TI) - RW")
            TagView.Items.Add("Typ 5 - HITAG 2 - RW")
            TagView.Items.Add("Typ 6 - EM4305 - RW")
            TagView.Items.Add("Typ 7 - EM4450/4550 (TITAN) - RW")
        End If
    End Sub

    Public Sub SetActiveButton()
        If (GetTagTypeFormItem(TagView.Items(TagView.SelectedIndex)) = 0) Or (GetTagTypeFormItem(TagView.Items(TagView.SelectedIndex)) = 2) Then
            cbReadWriteBox.Enabled = False
            NumBlock.Enabled = False
            btReadWriteData.Enabled = False
            txtData.Enabled = False
        Else
            cbReadWriteBox.Enabled = True
            NumBlock.Enabled = True
            btReadWriteData.Enabled = True
            txtData.Enabled = True
        End If
        If GetTagTypeFormItem(TagView.Items(TagView.SelectedIndex)) = 4 Then
            txtData.MaxLength = 16  ' HDX-Transponder mssen zum Schreiben 16 Zeichen haben
        Else
            txtData.MaxLength = 8
        End If
        If GetTagTypeFormItem(TagView.Items(TagView.SelectedIndex)) = 7 Then
            SpecialItem.Enabled = True
            TitanPassItem.Enabled = True
            Hitag2Item.Enabled = False
        ElseIf GetTagTypeFormItem(TagView.Items(TagView.SelectedIndex)) = 5 Then
            SpecialItem.Enabled = True
            TitanPassItem.Enabled = False
            Hitag2Item.Enabled = True
        Else
            SpecialItem.Enabled = False
            TitanPassItem.Enabled = False
            Hitag2Item.Enabled = False
        End If
    End Sub

    Private Sub btGetVersion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btGetVersion.Click
        Dim Version As String = ""
        Version = fc.MyBTLF.GetVersion
        InfoAdd(Version)
    End Sub

    Public Function GetTagTypeIndex(ByVal value As Integer) As Integer
        Dim i As Integer
        Dim tmp As String
        For i = 0 To TagView.Items.Count - 1
            tmp = TagView.Items(i)
            tmp = tmp.Substring(4, 1)
            If value = CInt(tmp) Then
                GetTagTypeIndex = i
                Exit Function
            End If
        Next
        Return GetTagTypeIndex
    End Function

    Private Function GetTagTypeFormItem(ByVal value As String) As Integer
        'Typ 0 - EM 41xx (UNIQUE) - RO
        Dim tmp As String
        tmp = value.Substring(4, 1)
        Return CInt(tmp)
    End Function


    Private Sub TagView_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TagView.SelectedIndexChanged
        Dim MyPassDlg As New frmPass
        Dim MyText As String
        Dim MyResult As Integer
        Dim MyItem As Integer
        MyText = ""
        MyItem = TagView.SelectedIndex
        'fc.TagType = TagView.SelectedIndex ' wurde umgebaut, nur Transponder die in der Firmenversion sind, soll man sehen
        fc.TagType = GetTagTypeFormItem(TagView.Items(TagView.SelectedIndex))
        fc.TagName = TagView.Items(TagView.SelectedIndex)
        btReadTransponder.Text = "Read Transponder (" & fc.TagType.ToString & ")"
        SetActiveButton()
        Exit Sub
        If IsFirst Then
            'fc.TagType = TagView.SelectedIndex
            fc.TagType = GetTagTypeFormItem(TagView.Items(TagView.SelectedIndex))
            fc.TagName = TagView.Items(TagView.SelectedIndex)
            btReadTransponder.Text = "Read Transponder (" & fc.TagType.ToString & ")"
            SetActiveButton()
            IsFirst = True
            Exit Sub
        End If
        Try
            MyPassDlg.txtPassword.Focus()
            MyResult = MyPassDlg.ShowDialog()
            MyResult = MyPassDlg.MyResult
            If MyResult = 1 Then
                MyText = MyPassDlg.txtPassword.Text
            End If
        Finally
            If Not MyPassDlg Is Nothing Then
                MyPassDlg.Dispose()
                MyPassDlg = Nothing
            End If
        End Try
        If MyResult = 1 Then
            If MyText = "0147" Then
                MsgBox("Change Tag-Typ successful")
                'fc.TagType = TagView.SelectedIndex
                fc.TagType = GetTagTypeFormItem(TagView.Items(TagView.SelectedIndex))
                fc.TagName = TagView.Items(TagView.SelectedIndex)
                btReadTransponder.Text = "Read Transponder (" & fc.TagType.ToString & ")"
                SetActiveButton()
                Exit Sub
            End If
        End If
        MsgBox("No Change Tag-Typ")
        IsFirst = True
        'TagView.SelectedIndex = fc.TagType
        TagView.SelectedIndex = MyItem
        IsFirst = False
    End Sub

    Public Sub ReadTransponder()
        IsKeyAction = True
        btReadTransponder_Click(Nothing, Nothing)
        IsKeyAction = False
    End Sub


    Private Sub btReadTransponder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btReadTransponder.Click
        'fc.TagType = TagView.SelectedIndex
        fc.TagType = GetTagTypeFormItem(TagView.Items(TagView.SelectedIndex))
        Try
            btReadTransponder.Enabled = False
            btReadWriteData.Enabled = False
            btGetVersion.Enabled = False
            If cbConti.Checked Then
                InfoAdd("Start Continues Read")
            End If
            Do
                'InfoAdd("Search Transponder...")
                System.Windows.Forms.Application.DoEvents()
                'fc.TagType = GetTagTypeFormItem(TagView.Items(TagView.SelectedIndex))
                If fc.TagType = 7 Then
                    fc.MyBTLF.TitanPassword = "00000000"
                End If
                fc.RFIDData = fc.MyBTLF.SelectTag(fc.TagType)
                If (fc.RFIDData Like "*- 1*") Or (fc.RFIDData Like "*- 2*") Or (fc.RFIDData Like "*- 3*") Or (fc.RFIDData Like "*- 4*") Or (fc.RFIDData Like "*- 5*") Or (fc.RFIDData Like "*- 6*") Then
                    InfoAdd("[" & fc.RFIDData & " ] No Transponder selected")
                ElseIf fc.RFIDData = "Error: 54" Then
                    InfoAdd("[54] Not available in this firmware")
                ElseIf fc.RFIDData = "- 99" Then
                    InfoAdd("[- 99] Reader-Error")
                    InfoAdd("Reader = Power Down")
                Else
                    InfoAdd("TAG-Nr. :" & fc.RFIDData)
                    fc.PlaySound()
                End If
            Loop Until Not cbConti.Checked
        Finally
            btReadTransponder.Enabled = True
            btReadWriteData.Enabled = True
            btGetVersion.Enabled = True
        End Try
    End Sub

    Public Sub InfoAdd(ByVal Value As String)
        Try
            If (Value = "") Or (Len(Value) = 0) Then
                Exit Sub
            End If
            'Dim itmp As New Windows.Forms.ListViewItem(Value)
            ListBox1.Items.Add(Value)
            ListBox1.SelectedIndex = ListBox1.Items.Count - 1
            If ListBox1.Items.Count >= 1000 Then
                ListBox1.Items.Clear()
            End If
        Catch ex As Exception
            '            WriteErrorFile(ex.Message)
        End Try

    End Sub

    'Private Sub MyTLM30_TLMData(ByVal Sender As Object, ByVal Direction As String, ByVal Data As String) Handles MyTLM30.TLMData
    '   If cbEvent.Checked Then
    '      InfoAdd(Direction & " " & Data)
    ' End If
    'End Sub

    Private Sub btReadWriteData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btReadWriteData.Click
        ReadTransponder()
        If Not fc.MyBTLF.IsTagSelect Then
            Exit Sub
        End If
        Try
            cbReadWriteBox.Enabled = False
            If cbReadWriteBox.SelectedIndex = 0 Then
                txtData.Text = ""
                fc.RFIDData = fc.MyBTLF.ReadTagData(fc.TagType, NumBlock.Value.ToString)
                If (fc.RFIDData = "- 1") Then
                    InfoAdd("Read Error")
                End If
                If (fc.RFIDData = "- 2") Then
                    InfoAdd("Read Error")
                End If
                If fc.RFIDData.Length >= 8 Then
                    InfoAdd("Tag-Data: " & fc.RFIDData)
                    txtData.Text = fc.RFIDData
                End If
            End If
            If cbReadWriteBox.SelectedIndex = 1 Then
                fc.RFIDData = fc.MyBTLF.WriteTagData(fc.TagType, NumBlock.Value.ToString, txtData.Text)
                If (fc.RFIDData = "- 1") Then
                    InfoAdd("Write Error")
                End If
                If (fc.RFIDData = "- 2") Then
                    InfoAdd("Write Error")
                End If
                If (fc.RFIDData = "- 3") Then
                    InfoAdd("Block length Error")
                End If
                If (fc.RFIDData Like "*+*") Then
                    InfoAdd("Write OK")
                End If
            End If
        Finally
            cbReadWriteBox.Enabled = True
        End Try
    End Sub

    Private Sub ExitItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitItem.Click
        If cbConti.Checked Then
            cbConti.Checked = False
            InfoAdd("Stop Continues Read")
        End If
        If MsgBox("Close Form ?", MsgBoxStyle.YesNo, Text) = MsgBoxResult.Yes Then
            Close()
        End If
    End Sub


    Private Sub cbReadWriteBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbReadWriteBox.SelectedIndexChanged
        btReadWriteData.Text = cbReadWriteBox.Text
    End Sub

    Private Sub frmLF_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyUp

    End Sub

    Private Sub frmLF_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cbReadWriteBox.SelectedIndex = 0
        CheckBox1.Checked = fc.MyBTLF.CTSInfo
    End Sub

    Private Sub TitanPassItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TitanPassItem.Click
        Dim frmPasswordDlg As New frmPassword
        frmPasswordDlg.txtPassword1.Text = fc.MyBTLF.TitanPassword
        frmPasswordDlg.txtPassword2.Text = fc.MyBTLF.TitanPassword
        frmPasswordDlg.lbTagInfo.Text = fc.TagName
        frmPasswordDlg.ShowDialog()
        fc.MyBTLF.TitanPassword = frmPasswordDlg.txtPassword1.Text
        If Not frmPasswordDlg Is Nothing Then
            frmPasswordDlg.Dispose()
            frmPasswordDlg = Nothing
        End If
    End Sub

    Private Sub Hitag2Item_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Hitag2Item.Click
        Dim frmPasswordDlg As New frmPassword
        frmPasswordDlg.txtPassword1.Text = fc.MyBTLF.Hitag2Password
        frmPasswordDlg.txtPassword2.Text = fc.MyBTLF.Hitag2Password
        frmPasswordDlg.lbTagInfo.Text = fc.TagName
        frmPasswordDlg.ShowDialog()
        fc.MyBTLF.Hitag2Password = frmPasswordDlg.txtPassword1.Text
        If Not frmPasswordDlg Is Nothing Then
            frmPasswordDlg.Dispose()
            frmPasswordDlg = Nothing
        End If
    End Sub

    Private Sub CheckBox1_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckStateChanged
        If CheckBox1.Checked Then
            fc.MyBTLF.RTS = True
        Else
            fc.MyBTLF.RTS = False
        End If
    End Sub

    Private Sub CheckBox2_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox2.CheckStateChanged
        fc.MyBTLF.PowerCheck = CheckBox2.Checked
    End Sub

    Private Sub ClearItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearItem.Click
        ListBox1.Items.Clear()
    End Sub

    Private Sub EventItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EventItem.Click
        EventItem.Checked = Not EventItem.Checked
    End Sub

    Private Sub cbConti_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbConti.CheckStateChanged
    End Sub
End Class
